library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity dynadisp_test is
    Port (
	 	clk : in std_logic;
		btn : in std_logic_vector(3 downto 0); 
	 	sw : in std_logic_vector(7 downto 0);
		A_n : out std_logic;
		B_n : out std_logic;
		C_n : out std_logic;
		D_n : out std_logic;
		E_n : out std_logic;
		F_n : out std_logic;
		G_n : out std_logic;
		DP_n : out std_logic;
		AN_n : out std_logic_vector(3 downto 0)
	 );
end dynadisp_test;

architecture RTL of dynadisp_test is
signal reset : std_logic;
signal swl : std_logic_vector(4 downto 0);
signal vcc4 : std_logic_vector(3 downto 0);
signal eight : std_logic_vector(3 downto 0);
	COMPONENT ssegdisp
	PORT(
		clk : IN std_logic;
		reset : IN std_logic;
		dot : IN std_logic_vector(3 downto 0);
		led_enable : IN std_logic_vector(3 downto 0);
		binary3 : IN std_logic_vector(3 downto 0);
		binary2 : IN std_logic_vector(3 downto 0);
		binary1 : IN std_logic_vector(3 downto 0);
		binary0 : IN std_logic_vector(3 downto 0);
		sw : in std_logic_vector(4 downto 0);          
		A_n : OUT std_logic;
		B_n : OUT std_logic;
		C_n : OUT std_logic;
		D_n : OUT std_logic;
		E_n : OUT std_logic;
		F_n : OUT std_logic;
		G_n : OUT std_logic;
		DP_n : OUT std_logic;
		AN_n : OUT std_logic_vector(3 downto 0)
		);
	END COMPONENT;
begin
	reset <= btn(3);
	vcc4 <= "1111";
	eight <= x"8";

	process(reset, clk) begin
		if reset='1' then
			swl <= (others => '0');
		elsif clk'event and clk='1' then
			swl <= sw(4 downto 0);
		end if;
	end process;

	Inst_ssegdisp: ssegdisp PORT MAP(
		clk => clk,
		reset => reset,
		dot => vcc4,
		led_enable => vcc4,
		binary3 => eight,
		binary2 => eight,
		binary1 => eight,
		binary0 => eight,
		sw => swl,
		A_n => A_n,
		B_n => B_n,
		C_n => C_n,
		D_n => D_n,
		E_n => E_n,
		F_n => F_n,
		G_n => G_n,
		DP_n => DP_n,
		AN_n => AN_n
	);
	

end RTL;
