-- Frequncy Divider for Dynamic Lighting
-- 1KHz clock
-- }X^[NbN1KHzlighting_enaɕ܂B
-- NbNgclk_frequencyKHzPʂŐݒ肵ĂBdefault50MHzłB
-- lcnt16rbgɂȂĂ̂ŁAclk_frequency65536ȏ̏ꍇ̓rbg𑝂₵ĂB

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

entity FreqDiv is
	generic(
		clk_frequency : integer := 50000 -- KHz
	);
	port(
		clk, reset : in std_logic;
		lighting_ena : out std_logic
	);
end FreqDiv;

architecture RTL of FreqDiv is
signal lcnt : std_logic_vector(15 downto 0);
begin
	process(reset, clk) begin -- Lighting frequency is 1KHz
		if reset='1' then
			lcnt <= (others => '0');
		elsif clk'event and clk='1' then
			if lcnt = conv_std_logic_vector(clk_frequency, 16) then
				lcnt <= (others => '0');
			else
				lcnt <= lcnt + 1;
			end if;
		end if;
	end process;
	
	lighting_ena <= '1' when lcnt = conv_std_logic_vector(clk_frequency,  16) else '0';
--	lighting_ena <= '1';
end RTL;
		
		